unit functions;

interface
uses
MyIniFiles,
Classes,
SysUtils;

type
PluginSettings=record
 UseMulti:boolean;
 Mp3Enable:boolean;
 mp3ttbused:string;
 Mp3id3v2:boolean;
 Format:string;
 ConvertSpaces:boolean;
 end;

Function rus2lat (text:string):string;
Function lat2rus (text:string):string;
Function translit (text:string):string;
Function lat2rusF (text:string):string;
Function TranslitUser (text:string;TranslitTable:String):string;
Function SymbolsReplace (text:string;SymbolsTable:String):string;
Function SymTranslit (text:string;SymbolsTable:String):string;


var
settings:PluginSettings;

implementation

Function lat2rus (text:string):string;
var
i:byte;
Begin
result:='';
for i:=1 to length (text) do
 begin
 if text[i]=' ' then
  begin
  if Settings.ConvertSpaces then result:=result+'_' else result:=result+' ';
  Continue;
  end;
 if text[i]='Q' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='W' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='E' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='R' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='T' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='Y' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='U' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='I' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='O' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='P' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='A' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='S' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='D' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='F' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='G' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='H' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='J' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='K' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='L' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='Z' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='X' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='C' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='V' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='B' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='N' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='M' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='q' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='w' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='e' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='r' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='t' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='y' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='u' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='i' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='o' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='p' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='a' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='s' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='d' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='f' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='g' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='h' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='j' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='k' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='l' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='z' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='x' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='c' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='v' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='b' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='n' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='m' then
  begin
  result:=result+'';
  Continue;
  end;
 result:=result+text[i];
 end;
End;

Function rus2lat (text:string):string;
var
i:byte;
Begin
result:='';
for i:=1 to length (text) do
 begin
 if text[i]=' ' then
  begin
  if Settings.ConvertSpaces then result:=result+'_' else result:=result+' ';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'Yo';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'Y';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'Z';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'U';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'K';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'E';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'N';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'G';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'Sh';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'Shz';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'Z';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'H';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'`';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'F';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'I';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'V';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'A';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'P';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'R';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'O';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'L';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'D';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'Jz';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'E';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'Ya';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'Ch';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'S';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'M';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'I';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'T';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'''';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'B';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'Yu';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'yo';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'y';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'z';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'u';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'k';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'e';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'n';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'g';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'sh';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'shz';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'z';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'h';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'`';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'f';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'i';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'v';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'a';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'p';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'r';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'o';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'l';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'d';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'jz';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'e';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'ya';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'ch';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'s';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'m';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'i';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'t';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'''';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'b';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'yu';
  Continue;
  end;
 result:=result+text[i];
 end;
End;

Function translit (text:string):string;
var
i:byte;
Begin
result:='';
for i:=1 to length (text) do
 begin
 if text[i]=' ' then
  begin
  if Settings.ConvertSpaces then result:=result+'_' else result:=result+' ';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'U';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'U,';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'Y';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'K';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'E';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'H';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'I`';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'III';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'III,';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'3';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'X';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'''b';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'oIo';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'bI';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'B';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'A';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'I7';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'p';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'O';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'JI';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'D';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'>I<';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'3';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'&I';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'4';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'C';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'M';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'U';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'T';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'b';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'6';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'I0';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'u';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'u,';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'y';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'k';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'e';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'H';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'I`';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'iii';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'iii,';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'3';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'x';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'`b';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'oIo';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'bI';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'B';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'a';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'I7';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'p';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'o';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'JI';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'d';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'>i<';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'3';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'&i';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'4';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'c';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'m';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'u';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'T';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'b';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'6';
  Continue;
  end;
 if text[i]='' then
  begin
  result:=result+'I0';
  Continue;
  end;
 result:=result+text[i];
 end;
End;

Function lat2rusF (text:string):string;
var
i:byte;
tmp:string;
Begin
result:='';
text:=lowercase (text);
i:=0;
while i<length (text) do
 begin
 if copy (text,i+1,5) = 'nctio' then
  begin
  result:=result+'';
  i:=i+5;
  continue;
  end;
 if copy (text,i+1,5) = 'ation' then
  begin
  result:=result+'';
  i:=i+5;
  continue;
  end;
 if copy (text,i+1,2) = 'ty' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'ct' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'cs' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'eu' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'me' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,3) = 'les' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,2) = 'ha' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'hi' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,3) = 'hoy' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,2) = 'ho' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'hu' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'hy' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'sh' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'ch' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,3) = 'sch' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,3) = 'nes' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,3) = 'exa' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,3) = 'rce' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,2) = 'ea' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'il' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'ge' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'ow' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,3) = 'mes' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,3) = 'lib' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,3) = 'new' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,2) = 'sm' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'oy' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'th' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'ph' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'im' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'gh' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,3) = 'tle' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,2) = 'gi' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'ly' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'oo' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'mu' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,3) = 'all' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,3) = 'iew' then
  begin
  result:=result+'''';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,3) = 'ake' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,2) = 'ee' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,3) = 'ace' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,3) = 'new' then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if copy (text,i+1,2) = 'ck' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if copy (text,i+1,2) = 'hu' then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if (copy (text,i+1,2) = 'i ') {or (copy (text,i+1,2) = 'i')} then
  begin
  result:=result+' ';
  i:=i+2;
  continue;
  end;
 tmp:=copy (text,i+1,2);
 if (copy (text,i+1,2) = 'e ') {or (copy (text,i+1,2) = '') }then
  begin
  result:=result+' ';
  i:=i+2;
  continue;
  end;
  tmp:=copy (text,i+1,3);
 if (copy (text,i+1,3) = 'm ') {or (copy (text,i+1,3) = 'm') }then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if (copy (text,i+1,2) = 'n ') {or (copy (text,i+1,3) = 'n') }then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;

 if (copy (text,i+1,2) = 'gg') then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;
 if (copy (text,i+1,3) = 'cut') then
  begin
  result:=result+'';
  i:=i+3;
  continue;
  end;
 if (copy (text,i+1,2) = 'li') then
  begin
  result:=result+'';
  i:=i+2;
  continue;
  end;

 inc (i);
 if text[i]='q' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='w' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='e' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='r' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='t' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='y' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='u' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='i' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='o' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='p' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='a' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='s' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='d' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='f' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='g' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='h' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='j' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='k' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='l' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='z' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='x' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='c' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='v' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='b' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='n' then
  begin
  result:=result+'';
  Continue;
  end;
 if text[i]='m' then
  begin
  result:=result+'';
  Continue;
  end;
 result:=result+text[i];
 end;
End;

Function TranslitUser (text:string;TranslitTable:String):string;
var
TTable:TIniFile;
i:byte;
temp:string;
Begin
result:='';
TTable:=TIniFile.Create(TranslitTable);
for i:=1 to Length (text) do
 Begin
 Temp:=TTable.ReadString('',text[i],'',True);

 if (Text[i]=' ') and Settings.ConvertSpaces then temp:='_';

 if temp='' then temp:=text[i];
 result:=result+temp;
 end;
TTable.free;
End;

Function SymbolsReplace (text:string;SymbolsTable:String):string;
var
TTable:TIniFile;
i:byte;
temp:string;
Begin
result:='';
TTable:=TIniFile.Create(SymbolsTable);
temp:=ttable.ReadString('',text,'',True);
 if temp='' then temp:=text[i];
 result:=result+temp;
ttable.Free;
End;

Function SymTranslit (text:string;SymbolsTable:String):string;
var
TTable:TIniFile;
x,x2:integer;
i:byte;
text2,temp:string;
s,ExList:Tstrings;
{ Function Exc (what:string):boolean;
  var
  xx:integer;
  c:string;
  begin
  result:= false;
  for xx:=0 to ExList.Count-1 do
   begin
   c:=copy (ExList.Strings [xx],1,pos ('=',ExList.Strings [xx])-1);
   if c=what then
    begin
    result:=true;
    break;
    end;
   end;
  end;}
Begin
i:=0;
s:=TStringList.Create;
ExList:=TStringList.Create;
result:='';
TTable:=TIniFile.Create(SymbolsTable);
TTable.ReadSection('Symbols',s);
text2:=text;
TTable.ReadSection('Exceptions',ExList);
while i<length (text2) do
 begin
 temp:='';
 for x:=0 to s.Count -1 do
//  begin
{  if (x=ExList.Count) then break;
  temp:=copy (text2,i+1,length (ExList.Strings [x]));
  if (ExList.Strings [x]=copy (text2,i+1,length (ExList.Strings [x]))) then
   begin
   result:=result+temp;
   i:=i+length (ExList.Strings [x]);
   break;
   end;
  end;                    }
//---------------------
// if x>ExList.count-1 then
  begin
  temp:=copy (text2,i+1,length (s.Strings [x]));
  if s.Strings [x]=copy (text2,i+1,length (s.Strings [x])) then
   begin
   temp:=s.Strings [x];
   result:=result+TTable.ReadString('Symbols',temp,'',True);
   i:=i+length (s.Strings [x]);
   break;
   end;
  end;
//---------------------
  if x>s.Count-1 then
   begin
   Temp:=TTable.ReadString('Translit',text2[i+1],'',true);
   if temp='' then temp:=text2[i+1];
   if text2[i+1]<>lowercase (text)[i+1] then temp:=UpperCase (temp);
   result:=result+temp;
   inc (i);
   end;
  end;
TTable.Free;
s.Free;
exList.Free;
End;




Begin

end.